import 'package:flutter/material.dart';
import 'package:animated_background/animated_background.dart';

class AnimasyonluArkaplan extends StatefulWidget {
  final Widget child;
  final int animasyonTuru;
  final double genislik;
  final double yukseklik;

  final int parcaSayisi;
  final double maxParcaBoyutu;
  final double minParcaBoyutu;
  final Color parcaRengi;
  final String resimYolu;
  final double maxParcaGorunurlulugu;
  final double minParcaGorunurlulugu;
  AnimasyonluArkaplan({this.child, this.animasyonTuru = 1, this.genislik = 300, this.yukseklik = 300, this.parcaSayisi = 10, this.maxParcaBoyutu = 20, this.minParcaBoyutu = 10, this.parcaRengi = Colors.amber, this.resimYolu, this.maxParcaGorunurlulugu = 0.5, this.minParcaGorunurlulugu = 0.1});

  @override
  _AnimasyonluArkaplanState createState() => new _AnimasyonluArkaplanState();
}

class _AnimasyonluArkaplanState extends State<AnimasyonluArkaplan> with TickerProviderStateMixin {
  @override
  Widget build(BuildContext context) {
    return Container(
      width: widget.genislik,
      height: widget.yukseklik,
      child: AnimatedBackground(
        behaviour: widget.animasyonTuru == 1
            ? RacingLinesBehaviour(numLines: widget.parcaSayisi)
            : widget.animasyonTuru == 2
                ? BubblesBehaviour(
                    options: BubbleOptions(
                    bubbleCount: widget.parcaSayisi,
                    maxTargetRadius: widget.maxParcaBoyutu,
                    minTargetRadius: widget.minParcaBoyutu,
                  ))
                : widget.animasyonTuru == 3
                    ? RandomParticleBehaviour(
                        options: ParticleOptions(
                            particleCount: widget.parcaSayisi,
                            maxOpacity: widget.maxParcaGorunurlulugu,
                            minOpacity: widget.minParcaGorunurlulugu,
                            spawnMaxRadius: widget.maxParcaBoyutu,
                            spawnMinRadius: widget.minParcaBoyutu,
                            spawnMaxSpeed: 60,
                            spawnMinSpeed: 10,
                            baseColor: widget.parcaRengi,
                            image: widget.resimYolu == null ? null : Image.asset(widget.resimYolu)))
                    : EmptyBehaviour(),
        vsync: this,
        child: Align(alignment: Alignment.center, child: widget.child),
      ),
    );
  }
}
