import 'dart:ui';

import 'package:flutter/material.dart';

class Arkaplan extends StatelessWidget {
  final Color arkaplanRengi;
  final Widget child;
  final String arkaplanResmi;
  final Color filtreRengi;
  final double filtreOpakligi;

  Arkaplan({this.child, this.arkaplanRengi, this.arkaplanResmi, this.filtreRengi = Colors.transparent, this.filtreOpakligi = 0.4});

  @override
  Widget build(BuildContext context) {
    return arkaplanResmi == null
        ? new Container(
            child: child,
            decoration: BoxDecoration(color: arkaplanRengi),
          )
        : new Container(
            decoration: new BoxDecoration(
              image: new DecorationImage(image: new AssetImage(arkaplanResmi), fit: BoxFit.cover, colorFilter: ColorFilter.linearToSrgbGamma()),
            ),
            child: new Card(
              color: filtreRengi.withOpacity(filtreOpakligi),
              margin: EdgeInsets.zero,
              elevation: 0.0,
              child: child,
            ),
          );
  }
}
