import 'package:flutter/material.dart';
import 'package:parallax_image/parallax_image.dart';

class Resim extends StatelessWidget {
  ///Tirnak icerisinde resmin yolunu yazmalisin. Orn 'resimler/foto1.png'
  String resimYolu;

  /// 1 girersen resimleri merkezinden resmi bozmadan gosterir. 2 girersen resimleri cekerek gosterir
  final int resimHizalamaTuru;

  ///Orn; 375
  final int genislik;

  ///Orn; 250
  final int yukseklik;

  Resim({this.resimYolu, this.resimHizalamaTuru = 1, this.genislik, this.yukseklik});

  @override
  Widget build(BuildContext context) {
    Widget current = !resimYolu.startsWith('http')
        ? Image.asset(
            resimYolu,
            width: genislik?.toDouble(),
            height: yukseklik?.toDouble(),
            fit: resimHizalamaTuru == 1 ? BoxFit.cover : BoxFit.fill,
          )
        : Image.network(
            resimYolu,
            width: genislik?.toDouble(),
            height: yukseklik?.toDouble(),
            fit: resimHizalamaTuru == 1 ? BoxFit.cover : BoxFit.fill,
          );

    return current;
  }
}

class AnimasyonluResim2 extends StatelessWidget {
  ///Tirnak icerisinde resmin yolunu yazmalisin. Orn 'resimler/foto1.png'
  String resimYolu;

  ///Orn; 375
  final int genislik;

  ///Orn; 250
  final int yukseklik;

  final Widget child;
  AnimasyonluResim2({this.resimYolu, this.genislik, this.yukseklik = 300, this.child});

  @override
  Widget build(BuildContext context) {
    return Container(
      width: genislik?.toDouble() ?? double.infinity,
      child: ParallaxImage(
        image: new AssetImage(resimYolu),
        extent: yukseklik.toDouble(),
        child: child ?? SizedBox(),
      ),
    );
  }
}

class AnimasyonluResim extends StatefulWidget {
  ///Tirnak icerisinde resmin yolunu yazmalisin. Orn 'resimler/foto1.png'
  String resimYolu;

  /// 1 girersen resimleri merkezinden resmi bozmadan gosterir. 2 girersen resimleri cekerek gosterir
  final int resimHizalamaTuru;

  ///Orn; 375
  final int genislik;

  ///Orn; 250
  final int yukseklik;

  AnimasyonluResim({this.resimYolu, this.resimHizalamaTuru = 1, this.genislik = 300, this.yukseklik = 300});

  @override
  _AnimasyonluResimState createState() => _AnimasyonluResimState();
}

class _AnimasyonluResimState extends State<AnimasyonluResim> with SingleTickerProviderStateMixin {
  bool hover = false;
  @override
  Widget build(BuildContext context) {
    var current = !widget.resimYolu.startsWith('http')
        ? AssetImage(
            widget.resimYolu,
          )
        : NetworkImage(
            widget.resimYolu,
          );

    return MouseRegion(
      onHover: (value) {
        setState(() {
          hover = true;
        });
      },
      onExit: (value) {
        setState(() {
          hover = false;
        });
      },
      child: Container(
        width: widget.genislik.toDouble(),
        height: widget.yukseklik.toDouble(),
        child: ClipRRect(
          child: AnimatedContainer(
            decoration: BoxDecoration(
              image: DecorationImage(
                image: current,
                fit: widget.resimHizalamaTuru == 1 ? BoxFit.cover : BoxFit.fill,
              ),
            ),
            alignment: Alignment.center,
            duration: Duration(milliseconds: 444),
            transform: hover
                ? (Matrix4.identity()
                  ..scale(1.1, 1.1)
                  ..translate(-widget.genislik / 20, -widget.genislik / 20))
                : Matrix4.identity()
              ..scale(1.0, 1.0),
          ),
        ),
      ),
    );
  }
}
