import 'package:animated_text_kit/animated_text_kit.dart';
import 'package:flutter/material.dart';

import 'helper.dart';

class Metin extends StatelessWidget with Helper {
  String yazi;

  /// Colors. ile baslarsan on tanimli renkler gelir. Yada Ornek: 'de3234'.color  - 6 haneli renk kodunu tirnak icinde yazip .color yaz.
  Color renk;

  int yaziBoyutu;

  /// 1-2-3-4-5-6-7-8-9 . Kalinlik seviyesini 1-9 arasinda belirleyebilirsin
  int kalinlik;

  /// true-false . true yazarsan yana yatik yazar
  bool italic;

  /// true-false . true yazarsan altini cizer
  bool altiCizili;

  /// true-false . true yazarsan ekran kuculdukce otomatik kucultur
  bool otomatikBoyut;

  Metin.zero();
  Metin({this.yazi, this.renk, this.altiCizili, this.italic, this.kalinlik, this.yaziBoyutu = 14, this.otomatikBoyut = false});

  @override
  Widget build(BuildContext context) {
    return new Text(
      yazi,
      style: TextStyle(
          color: renk, fontSize: otomatikBoyut == false ? yaziBoyutu.toDouble() : boyutKaysayisi(context) * yaziBoyutu, fontStyle: italic == true ? FontStyle.italic : FontStyle.normal, decoration: altiCizili == true ? TextDecoration.underline : TextDecoration.none, fontWeight: fontWeight(kalinlik)),
    );
  }
}

extension StringExtension on String {
  Color get color => Color(int.tryParse('0xff$this'));
}

class AnimasyonluMetin extends StatelessWidget with Helper {
  final int animasyonTuru;
  final List<String> metinler;

  ///Sadece animasyon 5 icin gerekli
  final List<Color> renkler;

  ///Sadece animasyon 6 icin gerekli
  final Color dalgaRengi;
  final int sure;
  final int yaziBoyutu;
  final Color yaziRengi;

  /// 1-2-3-4-5-6-7-8-9 . Kalinlik seviyesini 1-9 arasinda belirleyebilirsin
  int kalinlik;

  AnimasyonluMetin(
      {this.animasyonTuru,
      this.metinler,
      this.sure = 1200,
      this.yaziBoyutu = 18,
      this.yaziRengi: Colors.black,
      this.kalinlik = 3,
      this.dalgaRengi = Colors.pink,
      this.renkler = const [
        Colors.purple,
        Colors.blue,
        Colors.yellow,
        Colors.red,
      ]});

  @override
  Widget build(BuildContext context) {
    TextStyle style = TextStyle(color: yaziRengi, fontWeight: fontWeight(kalinlik), fontSize: yaziBoyutu.toDouble());
    if (animasyonTuru == 1) {
      return TypewriterAnimatedTextKit(speed: Duration(milliseconds: sure), totalRepeatCount: 4, pause: Duration(milliseconds: 1000), text: metinler, textStyle: style, displayFullTextOnTap: true, stopPauseOnTap: true);
    }
    if (animasyonTuru == 2) {
      return FadeAnimatedTextKit(duration: Duration(milliseconds: sure), totalRepeatCount: 4, pause: Duration(milliseconds: 1000), text: metinler, textStyle: style, displayFullTextOnTap: true, stopPauseOnTap: true);
    }
    if (animasyonTuru == 3) {
      return RotateAnimatedTextKit(duration: Duration(milliseconds: sure), totalRepeatCount: 4, pause: Duration(milliseconds: 1000), text: metinler, textStyle: style, displayFullTextOnTap: true);
    }
    if (animasyonTuru == 4) {
      return ScaleAnimatedTextKit(duration: Duration(milliseconds: sure), totalRepeatCount: 4, pause: Duration(milliseconds: 1000), text: metinler, textStyle: style, displayFullTextOnTap: true, stopPauseOnTap: true);
    }
//    if (animasyonTuru == 5) {
//      return ColorizeAnimatedTextKit(
//        speed: Duration(milliseconds: sure),
//        totalRepeatCount: 4,
//        pause: Duration(milliseconds: 1000),
//        text: metinler,
//        textStyle: style,
//        colors: renkler,
//      );
//    }
//    if (animasyonTuru == 6) {
//      return SizedBox(
//        width: 250.0,
//        child: TextLiquidFill(
//          text: 'LIQUIDY',
//          waveColor: Colors.blueAccent,
//          boxBackgroundColor: Colors.redAccent,
//          textStyle: TextStyle(
//            fontSize: 80.0,
//            fontWeight: FontWeight.bold,
//          ),
//          boxHeight: 300.0,
//        ),
//      );
//    }
    return Container();
  }
}
