import 'package:auto_animated/auto_animated.dart';
import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';

import 'helper.dart';
import 'package:mcg_extension/mcg_extension.dart';

extension Tween1 on Widget {
  Widget animasyon({int sure = 999, int gecikmeSuresu = 500, int animasyonTuru = 1, int animasyonMerkezi = 5}) {
    if (animasyonTuru == 1)
      return TweenAnimationBuilder(
          curve: Curves.easeInOut,
          tween: Tween<double>(begin: 0.0, end: 1.0),
          duration: Duration(milliseconds: sure),
          child: this,
          builder: (context, value, child) {
            return Opacity(
              opacity: value,
              child: Transform.scale(
                alignment: Helper().align(animasyonMerkezi),
                scale: (2 - value),
                child: child,
              ),
            );
          });
    if (animasyonTuru == 2)
      return HoverWidgetHelper(
        child: this,
      );

    return this;
  }

  Widget girisAnimasyonu() {
    return AnimateIfVisible(
      key: Key('item.${6.makeKey}'),
      duration: Duration(milliseconds: 500),
      builder: (
        BuildContext context,
        Animation<double> animation,
      ) =>
          SlideTransition(
        position: Tween<Offset>(
          begin: Offset(0, 0.3),
          end: Offset.zero,
        ).animate(animation),
        child: this,
      ),
    );
  }
}

class HoverWidgetHelper extends StatefulWidget {
  final Widget child;
  HoverWidgetHelper({this.child});

  @override
  _HoverWidgetHelperState createState() => new _HoverWidgetHelperState();
}

class _HoverWidgetHelperState extends State<HoverWidgetHelper> {
  bool hover = false;
  @override
  Widget build(BuildContext context) {
    return MouseRegion(
      child: AnimatedContainer(
        transform: !hover ? new Matrix4.identity() : new Matrix4.translationValues(0, -10, 0)
          ..translate(0, -15),
        duration: Duration(milliseconds: 300),
        child: widget.child,
      ),
      onHover: (state) {
        setState(() {
          hover = true;
        });
      },
      onExit: (state) {
        setState(() {
          hover = false;
        });
      },
    );
  }
}
