import 'package:auto_animated/auto_animated.dart';
import 'package:flutter/material.dart';
import 'package:scroll_to_index/scroll_to_index.dart';

import 'bolum.dart';

final autoScrollController = new AutoScrollController();

class Site extends StatelessWidget {
  final String siteAdi;
  final List<Bolum> bolumler;
  final Color siteArkaplanRengi;
  Site({this.siteAdi, this.bolumler, this.siteArkaplanRengi = Colors.white});

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      title: siteAdi ?? 'Site Adini gir',
      theme: ThemeData(primarySwatch: Colors.blue),
      home: Scaffold(
        backgroundColor: siteArkaplanRengi,
        body: AnimateIfVisibleWrapper(
          child: ListView(
            key: Key('listem'),
            controller: autoScrollController,
            children: bolumler.map((item) => item.kaydirmaKontrolu == null ? (item..kaydirmaKontrolu = autoScrollController) : item).toList(),
          ),
        ),
      ),
    );
  }
}
