import 'package:flutter/material.dart';

extension WidgetExtension on Widget {
  Widget kenarBoslugu({int hepsi, int dikey, int yatay, int sag, int sol, int yukari, int asagi}) {
    if (hepsi != null)
      return Padding(
        padding: EdgeInsets.all(hepsi.toDouble()),
        child: this,
      );
    if (dikey != null || yatay != null)
      return Padding(
        padding: EdgeInsets.symmetric(vertical: dikey?.toDouble() ?? 0, horizontal: yatay?.toDouble() ?? 0),
        child: this,
      );

    return Padding(
      padding: EdgeInsets.only(left: sol?.toDouble() ?? 0, right: sag?.toDouble() ?? 0, top: yukari?.toDouble() ?? 0, bottom: asagi?.toDouble() ?? 0),
      child: this,
    );
  }

  Widget koseYuvarlat({int hepsi, int solAlt, int sagAlt, int sagYukari, int solYukari}) {
    return ClipRRect(
      child: this,
      clipBehavior: Clip.antiAlias,
      borderRadius: hepsi != null
          ? BorderRadius.circular(hepsi.toDouble())
          : BorderRadius.only(bottomRight: Radius.circular(sagAlt?.toDouble() ?? 0), bottomLeft: Radius.circular(solAlt?.toDouble() ?? 0), topLeft: Radius.circular(solYukari?.toDouble() ?? 0), topRight: Radius.circular(sagYukari?.toDouble() ?? 0)),
    );
  }

  Widget daire() {
    return ClipRRect(child: this, clipBehavior: Clip.antiAlias, borderRadius: BorderRadius.circular(500.0));
  }
}
